#include <stdio.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>
#include <windows.h>
#include "ddlexec.h"
#include "wddlsvcs.h"

#define RW_ACCESS  128
#define RO_ACCESS   64
#define DD_ACCESS   32

struct
   {
     WORD wVirtKey;
     int  iMessage;
     WORD wRequest;
   }
   keyScroll [] =
   {
     VK_HOME,  WM_VSCROLL, SB_TOP,
     VK_END,   WM_VSCROLL, SB_BOTTOM,
     VK_PRIOR, WM_VSCROLL, SB_PAGEUP,
     VK_NEXT,  WM_VSCROLL, SB_PAGEDOWN,
     VK_UP,    WM_VSCROLL, SB_LINEUP,
     VK_DOWN,  WM_VSCROLL, SB_LINEDOWN,
     VK_LEFT,  WM_HSCROLL, SB_PAGEUP,
     VK_RIGHT, WM_HSCROLL, SB_PAGEDOWN
   };

typedef struct dictionary
{
   BYTE szPath[65];
   WORD iDictionary;
} DICTIONARYPATH;


HWND parentWND = 0L;
HANDLE parentInst = 0;
BYTE szUserName[21];
BYTE szPassword [10];
WORD iDictionary = 0xFFFF;
BYTE szDictionary[65];
TABLEPROPERTIES Table;
HANDLE hTableList = 0;
WORD   iTableCount = 0;
TABLELIST far *TableList;
BYTE szTableName[21];
BYTE szFileName [65];
BYTE ErrMsg[100];
WORD iFieldNdx = 0;
HCURSOR arrowCursor = 0;
HCURSOR waitCursor = 0;
HANDLE hDictList = 0;
DICTIONARYPATH far *DictList;
WORD numDictionaries = 0;
BOOL createTable = 0;
BOOL modifyTable = 0;
BOOL getTableProps = 0;
LONG iMaxRecSize = 0;
HANDLE hAddIndexList = 0;
ADDINDEXMAP far *addIndexList = 0;
WORD addIndexCount = 0;

extern BOOL far pascal GetTableNameProc     (HWND,unsigned,WORD,LONG);
extern BOOL far pascal GetTablePropsProc    (HWND,unsigned,WORD,LONG);
extern BOOL far pascal SelectDictionaryProc (HWND,unsigned,WORD,LONG);
extern BOOL far pascal CreateTableProc      (HWND,unsigned,WORD,LONG);
extern BOOL far pascal ModifyTableProc      (HWND,unsigned,WORD,LONG);
extern BOOL far pascal SecurityProc         (HWND,unsigned,WORD,LONG);
extern BOOL far pascal MaxRecLenProc        (HWND,unsigned,WORD,LONG);


void doFiles (void);

long far pascal WndProc           (HWND,unsigned,WORD,LONG);

int  FindDictInList (LPSTR);
void RemoveDictionary (int);
void createNewTable (void);
void modifyExistingTable (void);
void getTableProperties (void);
void getVersionInfo (void);

int PASCAL WinMain (HANDLE hInstance,
                    HANDLE hPrevInstance,
                    LPSTR lpszCmdLine,
                    int nCmdShow)
{
    static char szAppName[] = "DEFTEST";
    HWND        hWnd;
    MSG         msg;
    WNDCLASS    wndclass;

    if (!(hDictList = GlobalAlloc (GHND, (DWORD) 10 * sizeof (DICTIONARYPATH))))
    {
       MessageBox ((HWND)NULL, "Can't allocate memory !", " deftest ", MB_OK);
       return (FALSE);
    }


    if (!hPrevInstance)
    {
       wndclass.style            = CS_HREDRAW | CS_VREDRAW;
       wndclass.lpfnWndProc      = WndProc;
       wndclass.cbClsExtra       = 0;
       wndclass.cbWndExtra       = 0;
       wndclass.hInstance        = hInstance;
       wndclass.hIcon            = LoadIcon (hInstance, "DDLEXECICON");
       wndclass.hCursor          = LoadCursor (NULL, IDC_ARROW);
       wndclass.hbrBackground    = COLOR_APPWORKSPACE+1;
       wndclass.lpszMenuName     = szAppName;
       wndclass.lpszClassName    = szAppName;

       if (!RegisterClass (&wndclass))
          return (FALSE);
     }

     arrowCursor = wndclass.hCursor;
     waitCursor = LoadCursor (NULL, IDC_WAIT);

     hWnd = CreateWindow (szAppName,
                          " DDL Test Program ",
                          WS_OVERLAPPEDWINDOW | WS_HSCROLL | WS_VSCROLL,
                          CW_USEDEFAULT, 0,
                          CW_USEDEFAULT, 0,
                          NULL, NULL,
                          hInstance,
                          NULL);

     ShowWindow (hWnd, nCmdShow);
     UpdateWindow (hWnd);

     parentInst = hInstance;
     parentWND = hWnd;
     while (GetMessage (&msg, NULL, 0,0))
     {
        TranslateMessage (&msg);
        DispatchMessage (&msg);
     }
     return (msg.wParam);
}


LONG FAR PASCAL WndProc (HWND hWnd,
                         unsigned iMessage,
                         WORD wParam,
                         LONG lParam)
{
     FARPROC      lpprocAddress;

     switch (iMessage)
     {
        case WM_COMMAND :
             switch (wParam)
             {
                case IDM_SELECT_DICT  :
                     lpprocAddress = MakeProcInstance (SelectDictionaryProc,
                                                       parentInst);
                     DialogBox (parentInst, "DICTIONARY", parentWND, lpprocAddress);
                     FreeProcInstance (lpprocAddress);
                     break;

                case IDM_GETTABLE     :
                     if (iDictionary == 0xFFFF)
                     {
                        MessageBox (parentWND, "No dictionary open", " DDRDef ", MB_OK);
                         break;
                     }
                     lpprocAddress = MakeProcInstance (GetTableNameProc,
                                                       parentInst);
                     DialogBox (parentInst, "TABLES", parentWND, lpprocAddress);
                     FreeProcInstance (lpprocAddress);

                     if (createTable)
                        createNewTable ();
                     else
                        if (modifyTable)
                           modifyExistingTable ();
                        else
                           if (getTableProps)
                              getTableProperties ();
                     break;

                case IDM_ABOUT        :
                     getVersionInfo ();
                     break;
             }
             break;

        default:
             return (DefWindowProc (hWnd, iMessage, wParam, lParam));
      }

return ((long) 0);
}




int FindDictInList (LPSTR name)
{
   WORD i;
   DICTIONARYPATH far *tmpP;

   tmpP = DictList;
   for (i = 0; i < 10; ++i)
   {
      if (!(lstrcmpi (tmpP->szPath, name)))
         return (i);
      else
        ++tmpP;
   }

   tmpP = DictList;
   for (i = 0; i < 10; ++i)
   {
      if (!(lstrlen (tmpP->szPath)))
         return (i);
      else
         ++tmpP;
   }
   return (-1);
}


void RemoveDictionary (int Ndx)
{
   DICTIONARYPATH far *tmpP;

   if ((Ndx < 0) || (Ndx > 9))
     return;

   tmpP = (DICTIONARYPATH far *) GlobalLock (hDictList);
   tmpP += Ndx;
   tmpP->szPath[0] = (BYTE) 0;
   tmpP->iDictionary = -1;
}


void createNewTable ()
{
    FARPROC  lpprocAddress;
    WORD     status;

    lpprocAddress = MakeProcInstance (CreateTableProc, parentInst);
    DialogBox (parentInst, "CREATETABLE", parentWND, lpprocAddress);
    FreeProcInstance (lpprocAddress);

    if (strlen (szTableName))
    {
       lpprocAddress = MakeProcInstance (MaxRecLenProc,
                                      parentInst);
       DialogBox (parentInst, "RECSIZE", parentWND, lpprocAddress);
       FreeProcInstance (lpprocAddress);

       Table.hAltSeq = 0;
       SetCursor (waitCursor);
       status = DDLCreateTable (iDictionary, &Table);
       SetCursor (arrowCursor);
       if (status)
       {
          sprintf (ErrMsg, "Error - status: %d", status);
          MessageBox (parentWND, ErrMsg, " ERROR ", MB_OK);
       }
       else
          MessageBox (parentWND, "Table created", " OK ", MB_OK);
       if (Table.hIndexList)
          GlobalFree (Table.hIndexList);
       if (Table.hFieldList)
          GlobalFree (Table.hFieldList);
    }
}


void modifyExistingTable ()
{
    FARPROC  lpprocAddress;

    lpprocAddress = MakeProcInstance (ModifyTableProc, parentInst);
    DialogBox (parentInst, "MODIFYTABLE", parentWND, lpprocAddress);
    FreeProcInstance (lpprocAddress);
}



void getTableProperties ()
{
    FARPROC  lpprocAddress;
    WORD     status;

    strcpy (Table.szTableName, szTableName);
    SetCursor (waitCursor);
    status = DDLGetTableProperties (iDictionary, &Table);
    SetCursor (arrowCursor);

    if (status)
    {
       sprintf (ErrMsg, "Error getting properties: %d",status);
       MessageBox (parentWND, ErrMsg, " ERROR ", MB_OK);
    }
    else
    {
       lpprocAddress = MakeProcInstance (GetTablePropsProc,
                                         parentInst);
       DialogBox (parentInst, "FIELDINFO", parentWND,
                  lpprocAddress);
       FreeProcInstance (lpprocAddress);
    }
}


void getVersionInfo ()
{
   DDL_VERSION_INFO  versionInfo;
   WORD status;
   BYTE buffer[512];

   if (status = DDLGetVersionInfo (&versionInfo))
   {
       sprintf (ErrMsg, "Error getting version info: %d",status);
       MessageBox (parentWND, ErrMsg, " ERROR ", MB_OK);
       return;
   }

   strcpy (buffer, "DDRTest version 10,000,000.01");

   sprintf (&buffer[strlen (buffer)], "\n\nDDLSVCS        : %d.%d",
                                            versionInfo.iDDLVersion,
                                            versionInfo.iDDLRevision);

   if (versionInfo.iBType1 == 'N')
   {
      sprintf (&buffer [strlen (buffer)], "\nBtrieve requester : %d.%d",
                                           versionInfo.iBVersion1,
                                           versionInfo.iBRevision1);
      if (versionInfo.iBVersion2 != 0)
         sprintf (&buffer [strlen (buffer)], "\nBtrieve client : %d.%d",
                                              versionInfo.iBVersion2,
                                              versionInfo.iBRevision2);

   }
   else
      sprintf (&buffer [strlen (buffer)], "\nBtrieve        : %d.%d",
                                           versionInfo.iBVersion1,
                                           versionInfo.iBRevision1);

       MessageBox (parentWND, buffer, " DDR Versions ", MB_OK);
}

