
#define NOGDICAPMASKS
#define NOCOMM
#define NODRIVERS
#define NOLOGERROR
#define NODBCS
#define NOLANGUAGE
#define NOKEYBOARDINFO
#define NOFILEIO
#define NOSCALABLEFONT
#define NOWH
#define NOMDI
#define NORASTEROPS
#define NODRAWTEXT
#define OEMRESOURCE
#define NOATOM
#define NOCLIPBOARD
#define NOMETAFILE
#define NOKEYSTATES
#define NOMINMAX
#define NOOPENFILE
#define NOSOUND
#define NOKANJI
#define NOHELP
#define NOPROFILER
#define NODEFERWINDOWPOS

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ddlexec.h"
#include "wddlsvcs.h"

#define RW_ACCESS  128
#define RO_ACCESS   64
#define DD_ACCESS   32

typedef struct dictionary
{
   BYTE szPath[65];
   WORD iDictionary;
} DICTIONARYPATH;


extern HWND parentWND;
extern HANDLE parentInst;
extern BYTE szUserName[];
extern BYTE szPassword[];
extern WORD iDictionary;
extern BYTE szDictionary[];
extern TABLEPROPERTIES Table;
extern HANDLE hTableList;
extern WORD   iTableCount;
extern TABLELIST far *TableList;
extern BYTE szTableName[];
extern BYTE szFileName [];
extern BYTE ErrMsg[];
extern WORD iFieldNdx;
extern HCURSOR arrowCursor;
extern HCURSOR waitCursor;
extern HANDLE hDictList;
extern DICTIONARYPATH far *DictList;
extern WORD numDictionaries;
extern BOOL createTable;
extern BOOL modifyTable;
extern BOOL getTableProps;
extern LONG iMaxRecSize;
extern HANDLE hAddIndexList;
extern ADDINDEXMAP far *addIndexList;
extern WORD addIndexCount;


extern int  FindDictInList (LPSTR);
extern void RemoveDictionary (int);

BOOL far pascal GetTableNameProc     (HWND,unsigned,WORD,LONG);
BOOL far pascal GetTablePropsProc    (HWND,unsigned,WORD,LONG);
BOOL far pascal SelectDictionaryProc (HWND,unsigned,WORD,LONG);
BOOL far pascal CreateTableProc      (HWND,unsigned,WORD,LONG);
BOOL far pascal ModifyTableProc      (HWND,unsigned,WORD,LONG);
BOOL far pascal SecurityProc         (HWND,unsigned,WORD,LONG);
BOOL far pascal MaxRecLenProc        (HWND,unsigned,WORD,LONG);

BOOL FAR PASCAL GetTableNameProc (HWND hDlg,
                                  unsigned message,
                                  WORD wParam,
                                  LONG lParam)
{
  WORD status;
  WORD i, iTableNdx;

  switch (message)
  {
     case WM_INITDIALOG    :
          SetCursor (waitCursor);
          createTable = FALSE;
          modifyTable = FALSE;
          getTableProps = FALSE;
          szTableName[0] = (BYTE) 0;
          SetDlgItemText (hDlg, IDM_TABLEDICT, szDictionary);
          SendDlgItemMessage (hDlg, IDM_TABLES, LB_RESETCONTENT, 0, 0L);
          status = DDLGetTableNames (iDictionary, &iTableCount, &hTableList);
          if (status)
          {
             sprintf (ErrMsg, "Error getting table names: %d", status);
             SetCursor (arrowCursor);
             MessageBox (hDlg, ErrMsg, " XqlDef ", MB_OK);
             return (TRUE);
          }
          if (iTableCount)
          {
             TableList = (TABLELIST far *) GlobalLock (hTableList);
             for (i = 0; i < iTableCount; ++i)
             {
                SendDlgItemMessage (hDlg, IDM_TABLES, LB_ADDSTRING, 0,
                                   (LONG) TableList->szName);
                ++TableList;
             }
             GlobalUnlock (hTableList);
          }
          SetCursor (arrowCursor);
          return (TRUE);

     case WM_COMMAND       :
        switch (wParam)
        {
           case IDM_MODIFYTABLE:
                modifyTable = TRUE;   /* fall through to get tablename */

           case IDOK       :
                iTableNdx = SendDlgItemMessage (hDlg, IDM_TABLES, LB_GETCURSEL, 0, 0L);
                SendDlgItemMessage (hDlg, IDM_TABLES, LB_GETTEXT,
                                   iTableNdx, (LONG) ((LPSTR) szTableName));
                getTableProps = TRUE;
                EndDialog (hDlg, FALSE);
                return (TRUE);
                break;

           case IDM_DROPTABLE :
                iTableNdx = SendDlgItemMessage (hDlg, IDM_TABLES, LB_GETCURSEL, 0, 0L);
                SendDlgItemMessage (hDlg, IDM_TABLES, LB_GETTEXT,
                                   iTableNdx, (LONG) ((LPSTR) szTableName));
                SetCursor (waitCursor);
                status = DDLDropTable (iDictionary, szTableName);
                SetCursor (arrowCursor);
                if (status)
                {
                   sprintf (ErrMsg, "Error dropping table - status:%d", status);
                   MessageBox (hDlg, ErrMsg, " ERROR ", MB_OK);
                }
                else
                   SendDlgItemMessage (hDlg, IDM_TABLES, LB_DELETESTRING,
                                       iTableNdx, (LONG) 0);
                break;

           case IDM_CREATETABLE:
                createTable = TRUE;         /* continue on to CANCEL */
                EndDialog (hDlg, FALSE);
                return (TRUE);

           case IDCANCEL   :
                createTable = FALSE;
                modifyTable = FALSE;
                getTableProps = FALSE;
                EndDialog (hDlg, FALSE);
                return (TRUE);
        }
  }
return ((long) 0);
}



BOOL FAR PASCAL GetTablePropsProc (HWND hDlg,
                                   unsigned message,
                                   WORD wParam,
                                   LONG lParam)
{
  WORD  i;
  FIELDMAP far *pField;
  INDEXMAP far *pIndex;
  WORD iSegmentCount;
  BOOL bIndexFound;
  BYTE MsgBuf[512];
  BYTE tmpBuf[256];

  switch (message)
  {
     case WM_INITDIALOG    :
          SetWindowText (hDlg, (LPSTR) szTableName);
          SetDlgItemInt (hDlg, IDM_RECSIZE, Table.iRecSize, FALSE);

          if (Table.bVariable)
             SetDlgItemText (hDlg, IDM_VARIABLE, "Yes");
          else
             SetDlgItemText (hDlg, IDM_VARIABLE, "No");

          if (Table.bWriteAccess)
             SetDlgItemText (hDlg, IDM_TABLE_RIGHTS, "Write Access");
          else
             SetDlgItemText (hDlg, IDM_TABLE_RIGHTS, "No Write Access");

          ltoa (Table.dMaxRecSize, tmpBuf, 10);
          SetDlgItemText (hDlg, IDM_MAXRECSIZE, tmpBuf);
          SetDlgItemInt (hDlg, IDM_NUMFIELDS, Table.iFieldCount, FALSE);
          SetDlgItemInt (hDlg, IDM_NUMINDEXES, Table.iIndexCount, FALSE);
          SendDlgItemMessage (hDlg, IDM_FIELDS, LB_RESETCONTENT, 0, 0L);
          if (Table.iFieldCount)
          {
             pField = (FIELDMAP far *) GlobalLock (Table.hFieldList);
             for (i = 0; i < Table.iFieldCount; ++i)
             {
                SendDlgItemMessage (hDlg, IDM_FIELDS, LB_ADDSTRING, 0, (LONG) pField->szFieldName);
                ++pField;
             }
             GlobalUnlock (Table.hFieldList);
          }
          return (TRUE);
          break;

     case WM_COMMAND       :
        switch (wParam)
        {
           case IDM_FIELDS :
             if ((HIWORD (lParam)) == LBN_DBLCLK)
             {
                bIndexFound = FALSE;
                iSegmentCount = 0;
                iFieldNdx = SendDlgItemMessage (hDlg, IDM_FIELDS, LB_GETCURSEL, 0, 0L);
                pField = (FIELDMAP far *) GlobalLock (Table.hFieldList);
                pField += iFieldNdx;
                sprintf (MsgBuf, "Type:   %d\nOffset  %d\nLength: %d\nDecimal %d\n",
                         pField->iType, pField->iOffset, pField->iLength, pField->iDecimal);

                if ((pField->bAccessRights & RW_ACCESS) ||
                    (pField->bAccessRights & DD_ACCESS))
                   strcat (MsgBuf, "Read-Write Access\n");
                else
                   if (pField->bAccessRights & RO_ACCESS)
                      strcat (MsgBuf, "Read-Only Access\n");
                   else
                      strcat (MsgBuf, "No Rights\n");

                pIndex = (INDEXMAP far *) GlobalLock (Table.hIndexList);
                for (i = 0; i < Table.iIndexCount; ++i)
                {
                   if (pIndex->iFieldIndex == iFieldNdx)
                   {
                      sprintf (tmpBuf, "\nBtrNdx: %d  Segment: %d  Flags: %d\nName: %s",
                              pIndex->iIndex, pIndex->iSegment, pIndex->iFlags, pIndex->szIndexName);
                      strcat (MsgBuf, tmpBuf);
                   }
                   ++pIndex;
                }

                MessageBox (hDlg, MsgBuf, pField->szFieldName, MB_OK);

                GlobalUnlock (Table.hFieldList);
                GlobalUnlock (Table.hIndexList);
              }
              if (HIWORD (lParam) == LBN_SELCHANGE)
                iFieldNdx = SendDlgItemMessage (hDlg, IDM_FIELDS, LB_GETCURSEL, 0, 0L);
              break;

           case IDOK       :
                if (Table.hIndexList)
                   GlobalFree (Table.hIndexList);
                if (Table.hFieldList)
                   GlobalFree (Table.hFieldList);
                EndDialog (hDlg, FALSE);
                return (TRUE);
        }

  }
return ((long) 0);
}


BOOL FAR PASCAL SelectDictionaryProc (HWND hDlg,
                                      unsigned message,
                                      WORD wParam,
                                      LONG lParam)
{
   WORD i, j;
   int iDictNdx;
   WORD status;
   BYTE DictTmp[65];
   FARPROC lpprocAddress;
   char  msg[255];
   

  switch (message)
  {
     case WM_INITDIALOG    :
          strnset (szPassword, '\0', 10);
          szUserName[0] = '\0';
          SendDlgItemMessage (hDlg, IDM_DICTIONARYLIST, LB_RESETCONTENT, 0, 0L);
          DictList = (DICTIONARYPATH far *) GlobalLock (hDictList);
          for (i = 0; i < 10; ++i)
          {
             if (lstrlen (DictList->szPath))
                SendDlgItemMessage (hDlg, IDM_DICTIONARYLIST, LB_ADDSTRING, 0,
                                   (LONG) DictList->szPath);
             ++DictList;
          }
          GlobalUnlock (hDictList);
          SetDlgItemText (hDlg, IDM_DICTIONARYNAME, szDictionary);
          return (TRUE);

     case WM_COMMAND       :
        switch (wParam)
        {
           case IDM_DICTIONARYLIST   :
             if ((HIWORD (lParam)) == LBN_DBLCLK)
             {
                iDictNdx = SendDlgItemMessage (hDlg, IDM_DICTIONARYLIST, LB_GETCURSEL, 0, 0L);
                SendDlgItemMessage (hDlg, IDM_DICTIONARYLIST, LB_GETTEXT, iDictNdx,
                                   (LONG) ((LPSTR) DictTmp));
                DictList = (DICTIONARYPATH far *) GlobalLock (hDictList);
                if ((iDictNdx = FindDictInList (DictTmp)) >= 0)
                {
                   DictList += iDictNdx;
                   iDictionary = DictList->iDictionary;
                   lstrcpy (szDictionary, DictList->szPath);
                   GlobalUnlock (hDictList);
                   EndDialog (hDlg, FALSE);
                   return (TRUE);
                }
                GlobalUnlock (hDictList);
             }
             if ((HIWORD (lParam)) == LBN_SELCHANGE)
             {
                iDictNdx = SendDlgItemMessage (hDlg, IDM_DICTIONARYLIST, LB_GETCURSEL, 0, 0L);
                SendDlgItemMessage (hDlg, IDM_DICTIONARYLIST, LB_GETTEXT,
                                  iDictNdx, (LONG) ((LPSTR) DictTmp));
                SetDlgItemText (hDlg, IDM_DICTIONARYNAME, DictTmp);
             }
             break;

           case IDM_DICTIONARYSELECT :
                GetDlgItemText (hDlg, IDM_DICTIONARYNAME, DictTmp, 65);
                DictList = (DICTIONARYPATH far *) GlobalLock (hDictList);
                if ((iDictNdx = FindDictInList (DictTmp)) >= 0)
                {
                   DictList += iDictNdx;
                   if (DictList->szPath[0] != (BYTE) 0)
                   {
                      iDictionary = DictList->iDictionary;
                      lstrcpy (szDictionary, DictList->szPath);
                      GlobalUnlock (hDictList);
                      EndDialog (hDlg, FALSE);
                      return (TRUE);
                   }
                }
                else
                {
                   GlobalUnlock (hDictList);
                   MessageBox (hDlg, "Dictionary list is full", " XqlDef ", MB_OK);
                   EndDialog (hDlg, FALSE);
                   return (TRUE);
                }

                SetCursor (waitCursor);
                status = DDLOpenDataDictionary (DictTmp,
                                                &(DictList->iDictionary),
                                                szUserName, szPassword);
                SetCursor (arrowCursor);

                if (status == ACCESS_DENIED)
                {
                   lpprocAddress = MakeProcInstance (SecurityProc, parentInst);
                   if (DialogBox (parentInst, "SECURITY", hDlg, lpprocAddress))
                   {
                      FreeProcInstance (lpprocAddress);
                      GlobalUnlock (hDictList);
                      EndDialog (hDlg, FALSE);
                      return (TRUE);
                   }
                   FreeProcInstance (lpprocAddress);
                   SetCursor (waitCursor);
                   status = DDLOpenDataDictionary (DictTmp,
                                                   &(DictList->iDictionary),
                                                   szUserName, szPassword);
                   SetCursor (arrowCursor);
                }

                if (!status)
                {
                   iDictionary = DictList->iDictionary;
                   lstrcpy (DictList->szPath, DictTmp);
                   lstrcpy (szDictionary, DictList->szPath);
                   GlobalUnlock (hDictList);
                   EndDialog (hDlg, FALSE);
                   return (TRUE);
                }
                else
                {
                   if (status == 12)
                   {
                      if (MessageBox (hDlg, "Dictionary not found.\nCreate new one ?", " XqlDef ", MB_YESNO) == IDYES)
                      {
                         SetCursor (waitCursor);
                         status = DDLCreateDataDictionary (DictTmp, &j, 0);
                         SetCursor (arrowCursor);
                         if (status)
                         {
                            GlobalUnlock (hDictList);
                            sprintf (ErrMsg, "Create failed.  Status: %d", status);
                            MessageBox (hDlg, ErrMsg, " XqlDef ", MB_OK);
                            break;
                         }
                         else
                         {
                            DictList->iDictionary = j;
                            iDictionary = j;
                            lstrcpy (DictList->szPath, DictTmp);
                            lstrcpy (szDictionary, DictTmp);
                         }
                         GlobalUnlock (hDictList);
                         EndDialog (hDlg, FALSE);
                         return (TRUE);
                      }
                   }
                   GlobalUnlock (hDictList);
                   sprintf (ErrMsg, "Error opening dictionary: %d", status);
                   MessageBox (hDlg, ErrMsg, " XqlDef ", MB_OK);
                   break;
                }
                GlobalUnlock (hDictList);
                EndDialog (hDlg, FALSE);
                return (TRUE);

           case IDM_DICTIONARYCLOSE  :
                GetDlgItemText (hDlg, IDM_DICTIONARYNAME, DictTmp, 65);
                DictList = (DICTIONARYPATH far *) GlobalLock (hDictList);
                if ((iDictNdx = FindDictInList (DictTmp)) >= 0)
                {
                   DictList += iDictNdx;

                   SetCursor (waitCursor);
                   DDLCloseDataDictionary (DictList->iDictionary);
                   SetCursor (arrowCursor);
                   szDictionary[0] = (BYTE) 0;
                }
                GlobalUnlock (hDictList);
                RemoveDictionary (iDictNdx);
                EndDialog (hDlg, FALSE);
                return (TRUE);

           case IDCANCEL             :
                EndDialog (hDlg, FALSE);
                return (TRUE);
        }
        break;
  }
return ((long) 0);
}




BOOL FAR PASCAL CreateTableProc (HWND hDlg,
                                 unsigned message,
                                 WORD wParam,
                                 LONG lParam)
{
  BYTE szFieldName[25];
  BYTE szFileName [65];
  BYTE szNdxName [30];
  FIELDMAP far *FieldList;
  INDEXMAP far *IndexList;
  WORD iFieldType;
  WORD iFieldSize;
  WORD iDecPlaces;
  BOOL trans;
  WORD Findex;
  WORD Kindex;


  switch (message)
  {
     case WM_INITDIALOG    :
        Table.iFieldCount = 0;
        Table.iIndexCount = 0;
        Table.iRecSize = 0;
        iMaxRecSize = 0;
        szFileName[0] = (BYTE) 0;
        Table.hFieldList = GlobalAlloc (GHND, (DWORD) sizeof (FIELDMAP));
        Table.hIndexList = GlobalAlloc (GHND, (DWORD) sizeof (INDEXMAP));
        if (!(Table.hIndexList) || !(Table.hFieldList))
           MessageBox (hDlg, "Allocation Error", "ERROR", MB_OK);
        return (TRUE);

     case WM_COMMAND       :
        switch (wParam)
        {
           case IDM_CRTFIELDS    :
                if ((HIWORD (lParam)) == LBN_SELCHANGE)
                {                  /* reset all items for selected field */
                   if (Table.iFieldCount == 0)
                      break;
                   Findex = SendDlgItemMessage (hDlg, IDM_CRTFIELDS, LB_GETCURSEL, 0, 0L);
                   FieldList = (FIELDMAP far *) GlobalLock (Table.hFieldList);
                   FieldList += Findex;
                   SetDlgItemText (hDlg, IDM_CRTFIELDNAME, FieldList->szFieldName);
                   SetDlgItemInt (hDlg, IDM_CRTFIELDTYPE, FieldList->iType, 0);
                   SetDlgItemInt (hDlg, IDM_CRTFIELDSIZE, FieldList->iLength, 0);
                   SetDlgItemInt (hDlg, IDM_CRTDECPLACES, FieldList->iDecimal, 0);
                   GlobalUnlock (Table.hFieldList);
                }
                break;

           case IDM_CRTKEYS      :
                if ((HIWORD (lParam)) == LBN_SELCHANGE)
                {                  /* reset all items for selected field */
                   if (Table.iIndexCount == 0)
                      break;
                   Kindex = SendDlgItemMessage (hDlg, IDM_CRTKEYS, LB_GETCURSEL, 0, 0L);
                   IndexList = (INDEXMAP far *) GlobalLock (Table.hIndexList);
                   IndexList += Kindex;
                   SetDlgItemInt (hDlg, IDM_CRTKEYNUM, IndexList->iIndex, 0);
                   SetDlgItemInt (hDlg, IDM_CRTFIELDSIZE, IndexList->iSegment, 0);
                   GlobalUnlock (Table.hIndexList);
                }
                break;

           case IDM_SEGMENTFLAG   :
                if (IsDlgButtonChecked (hDlg, IDM_SEGMENTFLAG))
                   CheckDlgButton (hDlg, IDM_SEGMENTFLAG, 0);
                else
                   CheckDlgButton (hDlg, IDM_SEGMENTFLAG, 1);
                break;

           case IDM_NAMEDNDX   :
                if (IsDlgButtonChecked (hDlg, IDM_NAMEDNDX))
                {
                   CheckDlgButton (hDlg, IDM_NAMEDNDX, 0);
                   EnableWindow (GetDlgItem (hDlg, IDM_NDXNAME), FALSE);
                }
                else
                {
                   CheckDlgButton (hDlg, IDM_NAMEDNDX, 1);
                   EnableWindow (GetDlgItem (hDlg, IDM_NDXNAME), TRUE);
                }
                break;

           case IDM_ADDFIELD     :
                iFieldType = 0;
                iFieldSize = 0;
                iDecPlaces = 0;
                GetDlgItemText (hDlg, IDM_CRTFIELDNAME, szFieldName, 21);
                iFieldType = GetDlgItemInt (hDlg, IDM_CRTFIELDTYPE, &trans, 0);
                iFieldSize = GetDlgItemInt (hDlg, IDM_CRTFIELDSIZE, &trans, 0);
                iDecPlaces = GetDlgItemInt (hDlg, IDM_CRTDECPLACES, &trans, 0);
                if (strlen (szFieldName))
                   SendDlgItemMessage (hDlg, IDM_CRTFIELDS, LB_ADDSTRING, 0,
                                   (LONG) ((LPSTR) szFieldName));
                else
                   break;

                if ((Table.hFieldList = GlobalReAlloc (Table.hFieldList,
                                (DWORD) ((Table.iFieldCount+1) * sizeof (FIELDMAP)),
                                GHND)) == NULL)
                {
                   MessageBox (hDlg, "Allocation Error", "ERROR", MB_OK);
                   break;
                }
                FieldList = (FIELDMAP far *) GlobalLock (Table.hFieldList);
                FieldList += Table.iFieldCount;
                Table.iFieldCount += 1;
                lstrcpy (FieldList->szFieldName, szFieldName);
                FieldList->iType = iFieldType;
                if ((iFieldType ==  10) || (iFieldType == 11))
                   Table.bVariable = TRUE;
                FieldList->iLength = iFieldSize;
                FieldList->iOffset = Table.iRecSize;
                FieldList->iDecimal = iDecPlaces;
                Table.iRecSize += iFieldSize;
                GlobalUnlock (Table.hFieldList);
                SetDlgItemText (hDlg, IDM_CRTFIELDNAME, "");
                SetDlgItemInt (hDlg, IDM_CRTFIELDTYPE, 0, 0);
                SetDlgItemInt (hDlg, IDM_CRTFIELDSIZE, 0, 0);
                SetDlgItemInt (hDlg, IDM_CRTDECPLACES, 0, 0);
                SetFocus (GetDlgItem (hDlg, IDM_CRTFIELDNAME));
                break;

           case IDM_ADDKEY       :
                if ((Findex = SendDlgItemMessage (hDlg, IDM_CRTFIELDS,
                                              LB_GETCURSEL, 0, 0L)) == LB_ERR)
                {
                   MessageBox (hDlg, "Must select field", " ERROR ", MB_OK);
                   break;
                }
                if ((Table.hIndexList = GlobalReAlloc (Table.hIndexList,
                                (DWORD) ((Table.iIndexCount+1) * sizeof (INDEXMAP)),
                                GHND)) == NULL)
                {
                   MessageBox (hDlg, "Allocation Error", "ERROR", MB_OK);
                   break;
                }
                IndexList = (INDEXMAP far *) GlobalLock (Table.hIndexList);
                IndexList += Table.iIndexCount;
                Table.iIndexCount += 1;
                IndexList->iFieldIndex = Findex;
                IndexList->iIndex = GetDlgItemInt (hDlg, IDM_CRTKEYNUM, &trans, 0);
                IndexList->iSegment = GetDlgItemInt (hDlg, IDM_CRTKEYSEGMENT, &trans, 0);
                if (IsDlgButtonChecked (hDlg, IDM_SEGMENTFLAG))
                {
                   IndexList->iFlags = 275;
                   CheckDlgButton (hDlg, IDM_SEGMENTFLAG, 0);
                }
                else
                   IndexList->iFlags = 259;

                if (IsDlgButtonChecked (hDlg, IDM_NAMEDNDX))
                {
                   GetDlgItemText (hDlg, IDM_NDXNAME, IndexList->szIndexName, FIELDLEN);
                   SetDlgItemText (hDlg, IDM_NDXNAME, "");
                   EnableWindow (GetDlgItem (hDlg, IDM_NDXNAME), FALSE);
                   CheckDlgButton (hDlg, IDM_NAMEDNDX, 0);
                }
                else
                   IndexList->szIndexName[0] = '\0';

                SendDlgItemMessage (hDlg, IDM_CRTFIELDS, LB_GETTEXT,
                                   Findex, (LONG) ((LPSTR) szFieldName));
                SendDlgItemMessage (hDlg, IDM_CRTKEYS, LB_ADDSTRING, 0,
                                   (LONG) ((LPSTR) szFieldName));
                GlobalUnlock (Table.hIndexList);
                break;

           case IDOK             :
                GetDlgItemText (hDlg, IDM_CRTTABLE, szTableName, 21);
                strcpy (Table.szTableName, szTableName);
                if (GetDlgItemText (hDlg, IDM_FILENAME, szFileName, 65))
                   strcpy (Table.szPathName, szFileName);
                else
                   Table.szPathName[0] = (BYTE) 0;
                EndDialog (hDlg, FALSE);
                return (TRUE);

           case IDCANCEL         :
                GlobalFree (Table.hFieldList);
                GlobalFree (Table.hIndexList);
                Table.iFieldCount = 0;
                Table.iIndexCount = 0;
                szTableName[0] = (BYTE) 0;
                EndDialog (hDlg, FALSE);
                return (TRUE);
        }
  }
return ((long) 0);
}



BOOL FAR PASCAL ModifyTableProc (HWND hDlg,
                                 unsigned message,
                                 WORD wParam,
                                 LONG lParam)
{
  WORD i, j, status, Findex, Kindex, saveNdx;
  BOOL trans;
  BOOL iReorderIndexes;
  BYTE szFieldName[21];
  BYTE szIndexName[FIELDLEN];
  FIELDMAP far *FieldList;
  INDEXMAP far *IndexList;
  INDEXMAP far *tmpNdx;
  INDEXMAP far *savNdxP;

  switch (message)
  {
     case WM_INITDIALOG :
          addIndexCount = 0;
          strcpy (Table.szTableName, szTableName);
          SetCursor (waitCursor);
          if (status = DDLGetTableProperties (iDictionary, &Table))
          {
             sprintf (ErrMsg, "Error getting table properties: %d",status);
             SetCursor (arrowCursor);
             MessageBox (hDlg, ErrMsg, " ERROR ", MB_OK);
             return (FALSE);
          }

          SetDlgItemText (hDlg, MOD_TABLENAME, szTableName);
          SetDlgItemText (hDlg, MOD_FILENAME, Table.szPathName);

          if (Table.iFieldCount)
          {
             FieldList = (FIELDMAP far *) GlobalLock (Table.hFieldList);
             SetDlgItemText (hDlg, MOD_FIELDNAME, FieldList->szFieldName);
             SetDlgItemInt (hDlg, MOD_FIELDTYPE, FieldList->iType, 0);
             SetDlgItemInt (hDlg, MOD_FIELDSIZE, FieldList->iLength, 0);
             SetDlgItemInt (hDlg, MOD_DECPLACES, FieldList->iDecimal, 0);
             for (i = 0; i < Table.iFieldCount; ++i)
             {
                SendDlgItemMessage (hDlg, MOD_FIELDS, LB_INSERTSTRING, i,
                                          (DWORD) FieldList->szFieldName);
                 ++FieldList;
             }
             SendDlgItemMessage (hDlg, MOD_FIELDS, LB_SETCURSEL, 0, 0L);

             if (Table.iIndexCount != 0)
             {
                IndexList = (INDEXMAP far *) GlobalLock (Table.hIndexList);
                SetDlgItemInt (hDlg, MOD_KEYNUM, IndexList->iIndex, 0);
                SetDlgItemInt (hDlg, MOD_KEYSEGMENT, IndexList->iSegment, 0);
                if (IndexList->szIndexName[0])
                {
                   EnableWindow (GetDlgItem (hDlg, MOD_NDXNAME), TRUE);
                   SetDlgItemText (hDlg, MOD_NDXNAME, IndexList->szIndexName);
                   CheckDlgButton (hDlg, MOD_NAMEDNDX, 0);
                }
                for (i = 0; i < Table.iIndexCount; ++i)
                {
                   SendDlgItemMessage (hDlg, MOD_FIELDS, LB_GETTEXT,
                                       IndexList->iFieldIndex, (DWORD) szFieldName);
                   SendDlgItemMessage (hDlg, MOD_KEYS, LB_INSERTSTRING,
                                       i, (DWORD) szFieldName);
                   ++IndexList;
                }
                GlobalUnlock (Table.hIndexList);
                SendDlgItemMessage (hDlg, MOD_KEYS, LB_SETCURSEL, 0, 0L);
             }
             else
                EnableWindow (GetDlgItem (hDlg, MOD_DROPINDEX), FALSE);
             GlobalUnlock (Table.hFieldList);
          }
          SetCursor (arrowCursor);
          EnableWindow (GetDlgItem (hDlg, MOD_APPLYKEYS), FALSE);
          return (TRUE);

     case WM_COMMAND    :
        switch (wParam)
        {
           case MOD_FIELDS    :
                if ((HIWORD (lParam)) == LBN_SELCHANGE)
                {                  /* reset all items for selected field */
                   if (Table.iFieldCount == 0)
                      break;
                   Findex = SendDlgItemMessage (hDlg, MOD_FIELDS, LB_GETCURSEL, 0, 0L);
                   FieldList = (FIELDMAP far *) GlobalLock (Table.hFieldList);
                   FieldList += Findex;
                   SetDlgItemText (hDlg, MOD_FIELDNAME, FieldList->szFieldName);
                   SetDlgItemInt (hDlg, MOD_FIELDTYPE, FieldList->iType, 0);
                   SetDlgItemInt (hDlg, MOD_FIELDSIZE, FieldList->iLength, 0);
                   SetDlgItemInt (hDlg, MOD_DECPLACES, FieldList->iDecimal, 0);
                   GlobalUnlock (Table.hFieldList);
                }
                break;

           case MOD_KEYS      :
                if ((HIWORD (lParam)) == LBN_SELCHANGE)
                {                  /* reset all items for selected field */
                   if (Table.iIndexCount == 0)
                      break;
                   Kindex = SendDlgItemMessage (hDlg, MOD_KEYS, LB_GETCURSEL, 0, 0L);
                   IndexList = (INDEXMAP far *) GlobalLock (Table.hIndexList);
                   IndexList += Kindex;
                   SetDlgItemInt (hDlg, MOD_KEYNUM, IndexList->iIndex, 0);
                   SetDlgItemInt (hDlg, MOD_KEYSEGMENT, IndexList->iSegment, 0);
                   if (IndexList->iFlags == 275)
                      CheckDlgButton (hDlg, MOD_SEGMENTFLAG, TRUE);
                   else
                      CheckDlgButton (hDlg, MOD_SEGMENTFLAG, FALSE);
                   GlobalUnlock (Table.hIndexList);
                }
                break;

           case IDM_SEGMENTFLAG   :
                if (IsDlgButtonChecked (hDlg, MOD_SEGMENTFLAG))
                   CheckDlgButton (hDlg, MOD_SEGMENTFLAG, 0);
                else
                   CheckDlgButton (hDlg, MOD_SEGMENTFLAG, 1);
                break;

           case MOD_NAMEDNDX   :
                if (IsDlgButtonChecked (hDlg, MOD_NAMEDNDX))
                {
                   CheckDlgButton (hDlg, MOD_NAMEDNDX, 0);
                   EnableWindow (GetDlgItem (hDlg, IDM_NDXNAME), FALSE);
                }
                else
                {
                   CheckDlgButton (hDlg, MOD_NAMEDNDX, 1);
                   EnableWindow (GetDlgItem (hDlg, IDM_NDXNAME), TRUE);
                }
                break;

           case MOD_ADDKEY       :
                if (!hAddIndexList)
                {
                   if ((hAddIndexList = GlobalAlloc (GHND,
                                  (DWORD) (sizeof (ADDINDEXMAP) * 119))) == NULL)
                   {
                      MessageBox (hDlg, "Memory allocation failure", " ERROR ", MB_OK);
                      break;
                   }
                }

                if ((Findex = SendDlgItemMessage (hDlg, MOD_FIELDS,
                                              LB_GETCURSEL, 0, 0L)) == LB_ERR)
                {
                   MessageBox (hDlg, "Must select field", " ERROR ", MB_OK);
                   break;
                }
                SendDlgItemMessage (hDlg, MOD_FIELDS, LB_GETTEXT,
                                   Findex, (LONG) ((LPSTR) szFieldName));

                addIndexList = (ADDINDEXMAP far *) GlobalLock (hAddIndexList);
                addIndexList += addIndexCount;
                addIndexList->szIndexName[0] = NULL;
                lstrcpy (addIndexList->szFieldName, szFieldName);
                addIndexList->iIndex = GetDlgItemInt (hDlg, MOD_KEYNUM, &trans, 0);
                addIndexList->iSegment = GetDlgItemInt (hDlg, MOD_KEYSEGMENT, &trans, 0);
                if (IsDlgButtonChecked (hDlg, MOD_SEGMENTFLAG))
                {
                   addIndexList->iFlags = 275;
                   CheckDlgButton (hDlg, MOD_SEGMENTFLAG, 0);
                }
                else
                   addIndexList->iFlags = 259;

                if (IsDlgButtonChecked (hDlg, MOD_NAMEDNDX))
                {
                   GetDlgItemText (hDlg, MOD_NDXNAME, addIndexList->szIndexName, FIELDLEN);
                   CheckDlgButton (hDlg, MOD_NAMEDNDX, 0);
                   SetDlgItemText (hDlg, MOD_NDXNAME, "");
                   EnableWindow (GetDlgItem (hDlg, IDM_NDXNAME), FALSE);
                }
                else
                   addIndexList->szIndexName[0] = '\0';

                ++addIndexCount;
                GlobalUnlock (hAddIndexList);

                SendDlgItemMessage (hDlg, MOD_KEYS, LB_ADDSTRING,
                                   0, (LONG) ((LPSTR) szFieldName));

                if (!IsWindowEnabled (GetDlgItem (hDlg, MOD_APPLYKEYS)))
                   EnableWindow (GetDlgItem (hDlg, MOD_APPLYKEYS), TRUE);
                if (IsWindowEnabled (GetDlgItem (hDlg, MOD_DROPINDEX)))
                   EnableWindow (GetDlgItem (hDlg, MOD_DROPINDEX), FALSE);

                Table.iIndexCount += 1;
                Table.hIndexList = GlobalReAlloc (Table.hIndexList,
                                   (DWORD) Table.iIndexCount *
                                   sizeof(INDEXMAP), GHND);
                IndexList = (INDEXMAP far *) GlobalLock (Table.hIndexList);
                IndexList += (Table.iIndexCount - 1);
                IndexList->iIndex = addIndexList->iIndex;
                IndexList->iSegment = addIndexList->iSegment;
                IndexList->iFlags = addIndexList->iFlags;

                GlobalUnlock (hAddIndexList);
                GlobalUnlock (Table.hIndexList);
                break;

           case MOD_APPLYKEYS:
                addIndexList = (ADDINDEXMAP far *) GlobalLock (hAddIndexList);

                status = DDLAddIndex (iDictionary, szTableName, addIndexCount,
                                      addIndexList);
                if (status)
                {
                   for (i = 0; i < addIndexCount; ++i)
                   {
                      Kindex = SendDlgItemMessage (hDlg, MOD_KEYS, LB_FINDSTRING,
                                       0, (LONG) addIndexList->szFieldName);
                      if (Kindex != LB_ERR)
                         SendDlgItemMessage (hDlg, MOD_KEYS, LB_DELETESTRING,
                                             0, (LONG) 0L);
                   }
                   SendDlgItemMessage (hDlg, MOD_FIELDS, LB_SETCURSEL, 0, 0L);
                   SendDlgItemMessage (hDlg, MOD_KEYS, LB_SETCURSEL, 0, 0L);
                   sprintf (ErrMsg, "error adding new index; rc = %d", status);
                   MessageBox (hDlg, ErrMsg, " ERROR ", MB_OK);
                   GlobalUnlock (hAddIndexList);
                   GlobalFree (hAddIndexList);
                   hAddIndexList = 0;
                   break;
                }

                if ((Table.hIndexList = GlobalReAlloc (Table.hIndexList,
                                (DWORD) ((Table.iIndexCount + addIndexCount) *
                                          sizeof (INDEXMAP)),
                                GHND)) == NULL)
                {
                   MessageBox (hDlg, "Allocation Error", "ERROR", MB_OK);
                   if (!IsWindowEnabled (GetDlgItem (hDlg, MOD_DROPINDEX)))
                      EnableWindow (GetDlgItem (hDlg, MOD_DROPINDEX), TRUE);
                   break;
                }
                IndexList = (INDEXMAP far *) GlobalLock (Table.hIndexList);
                IndexList += Table.iIndexCount;
                Table.iIndexCount += addIndexCount;
                for (i = 0; i < addIndexCount; ++i)
                {
                   IndexList->iFieldIndex = SendDlgItemMessage (hDlg,
                                            MOD_FIELDS, LB_FINDSTRING,
                                            0, (LONG) addIndexList->szFieldName);
                   IndexList->iIndex      = addIndexList->iIndex;
                   IndexList->iSegment    = addIndexList->iSegment;
                   IndexList->iFlags      = addIndexList->iFlags;
                }
                GlobalUnlock (Table.hIndexList);
                GlobalUnlock (hAddIndexList);
                GlobalFree (hAddIndexList);
                hAddIndexList = 0;
                addIndexCount = 0;
                EnableWindow (GetDlgItem (hDlg, MOD_DROPINDEX), TRUE);
                break;

           case MOD_DROPINDEX:
                if (IsDlgButtonChecked (hDlg, MOD_NAMEDNDX))
                {
                   szIndexName[0] = '\0';
                   GetDlgItemText (hDlg, MOD_NDXNAME, szIndexName, FIELDLEN);
                   savNdxP = IndexList = (INDEXMAP far *) GlobalLock (Table.hIndexList);
                   for (i = 0; i < Table.iIndexCount; ++i)
                      if (!(lstrcmpi (IndexList->szIndexName, szIndexName)))
                         break;
                      else
                         ++IndexList;

                   if (i == Table.iIndexCount)
                   {
                      GlobalUnlock (Table.hIndexList);
                      MessageBox (hDlg, "Index name not defined in table", "ERROR", MB_OK);
                      break;
                   }
                   saveNdx = IndexList->iIndex;
                }
                else
                {
                   if ((Kindex = SendDlgItemMessage (hDlg, MOD_KEYS,
                                                 LB_GETCURSEL, 0, 0L)) == LB_ERR)
                   {
                      MessageBox (hDlg, "Must select key field", " ERROR ", MB_OK);
                      break;
                   }
                   szIndexName[0] = '\0';
                   savNdxP = IndexList = (INDEXMAP far *) GlobalLock (Table.hIndexList);
                   IndexList += Kindex;
                   saveNdx = IndexList->iIndex;
                }

                iReorderIndexes = TRUE;
                status = DDLDropIndex (iDictionary, szTableName, szIndexName,
                                       saveNdx, &iReorderIndexes);
                if (status)
                {
                   sprintf (ErrMsg, "Error dropping index; rc = %d", status);
                   MessageBox (hDlg, ErrMsg, " ERROR ", MB_OK);
                   break;
                }

                IndexList = savNdxP;
                tmpNdx = IndexList + 1;
                for (i = 0, j = 0; i < Table.iIndexCount; ++i)
                {
                   if (IndexList->iIndex == saveNdx)
                   {
                      if (i != (Table.iIndexCount -1))
                         _fmemcpy (IndexList, tmpNdx, sizeof (INDEXMAP));
                      --Table.iIndexCount;
                      SendDlgItemMessage (hDlg, MOD_KEYS, LB_DELETESTRING,
                                          j, (LONG) (LPSTR) 0L);
                   }
                   else
                   {
                      ++IndexList;
                      ++j;
                   }
                   ++tmpNdx;
                }

                if (iReorderIndexes)
                {
                   IndexList = savNdxP;
                   for (i = 0; i < Table.iIndexCount; ++i)
                   {
                      if (IndexList->iIndex > saveNdx)
                         --IndexList->iIndex;
                      ++IndexList;
                   }
                }
                SendDlgItemMessage (hDlg, MOD_KEYS, LB_SETCURSEL, 0, 0L);
                Kindex = Table.iIndexCount;
                GlobalUnlock (Table.hIndexList);
                if (Table.iIndexCount)
                {
                   if ((Table.hIndexList = GlobalReAlloc (Table.hIndexList,
                                   (DWORD) ((Kindex) * sizeof (INDEXMAP)),
                                   GHND)) == NULL)
                   {
                      MessageBox (hDlg, "Allocation Error", "ERROR", MB_OK);
                      EndDialog (hDlg, FALSE);
                      return (TRUE);
                   }
                }
                else
                {
                   GlobalFree (Table.hIndexList);
                   Table.hIndexList = NULL;
                }
                break;

           case IDOK:
                if (Table.hFieldList)
                   GlobalFree (Table.hFieldList);
                if (Table.hIndexList)
                   GlobalFree (Table.hIndexList);
                EndDialog (hDlg, FALSE);
                return (TRUE);
        }
        break;
  }
  return ((long) 0);
}



BOOL FAR PASCAL MaxRecLenProc (HWND hDlg,
                               unsigned message,
                               WORD wParam,
                               LONG lParam)
{
  BOOL trans;

  switch (message)
  {
     case WM_INITDIALOG :
          return (TRUE);

     case WM_COMMAND    :
          if (wParam == IDOK)
          {
             Table.dMaxRecSize = (DWORD) GetDlgItemInt (hDlg, IDM_MAXREC, &trans, 0);
             EndDialog (hDlg, FALSE);
             return (TRUE);
          }
          break;
  }
return ((long) 0);
}



BOOL FAR PASCAL SecurityProc (HWND hDlg,
                              unsigned message,
                              WORD wParam,
                              LONG lParam)
{

  switch (message)
  {
     case WM_INITDIALOG :
          return (TRUE);

     case WM_COMMAND    :
          if (wParam == IDOK)
          {
             GetDlgItemText (hDlg, IDM_USERNAME, szUserName, 65);
             GetDlgItemText (hDlg, IDM_PASSWORD, szPassword, 65);
             EndDialog (hDlg, FALSE);
             return (TRUE);
          }
          if (wParam == IDCANCEL)
             EndDialog (hDlg, TRUE);
          break;
  }
return ((long) 0);
}

